
procedure DoTankLogic;
var
 finalTankLevel;
begin
 enableTimer:=(RV(pumpRunning) and not RV(tankLevelIncreaseTD));
 value:=TMRS(tankLevelIncreaseTimer,'EN',enableTimer);

 finalTankLevel:=RV(tankLevel);
 WV(tankLevelIncreaseTT,TMRG(tankLevelIncreaseTimer,'TT'));
 if TMRG(tankLevelIncreaseTimer,'DN') then
  begin
   finalTankLevel:=finalTankLevel + 50;
   if (finalTankLevel < 0) then
    finalTankLevel:=0
   else if (finalTankLevel > 1000) then
    finalTankLevel:=1000;
   WV(tankLevelIncreaseTD,true);
  end
 else
  WV(tankLevelIncreaseTD,false);

 enableTimer:=(RV(tankValveOpened) and not RV(tankLevelDecreaseTD));
 value:=TMRS(tankLevelDecreaseTimer,'EN',enableTimer);
 WV(tankLevelDecreaseTT,TMRG(tankLevelDecreaseTimer,'TT'));
 if TMRG(tankLevelDecreaseTimer,'DN') then
  begin
   if (finalTankLevel >= 57) then
    finalTankLevel:=finalTankLevel - 57
   else if (finalTankLevel <= 0) then
    finalTankLevel:=0;
   WV(tankLevelDecreaseTD,true);
  end
 else
  WV(tankLevelDecreaseTD,false);

 WV(tankLevel,finalTankLevel);

//alarms
 WV(tankHiLevel,(finalTankLevel >=750));
 WV(tankHiHiLevel,(finalTankLevel >=900));

 WV(tankLoLevel,(finalTankLevel <=250));
 WV(tankLoLoLevel,(finalTankLevel <=100));

 if (RV(pumpRunning) and (finalTankLevel = 1000)) then
  WV(pumpSpeedCommand,0);

 value:=TMRS(tankFlowTimer,'EN',RV(tankValveOpened));
 tFlow:=RV(tankFlow);
 if TMRG(tankFlowTimer,'DN') then
  begin
   Inc(tFlow);
   if (tFlow >= 6) then
    tFlow:=0;
   WV(tankFlow,tFlow);
  end;
end;
